function Cidade(objCidade) {
	if (!objCidade)
		objCidade = {};
	this.id = objCidade.id;
	this.nome = objCidade.nome;
	this.alias = objCidade.alias;
	this.uf = objCidade.uf;
	this.estado = objCidade.estado;
	this.latitude = objCidade.latitude;
	this.longitude = objCidade.longitude;
	this.telefone1 = objCidade.telefone1;
	this.telefone2 = objCidade.telefone2;
	this.horario = objCidade.horario;
	this.observacao = objCidade.observacao;
	this.sobre = objCidade.sobre;
	this.logo = objCidade.logo;
	this.termos = objCidade.termos;
	this.estado_id = objCidade.estado_id;
}

Radar.cidades = {
	estado_selecionado: undefined,
	scroller: undefined,

	confirmar: function () {
		if (usuario.dados.cidade) {
			$('cadastrar_cidade').hide();
			usuario.salvar();
            Radar.tipos.dao.carregar();

			if (Radar.tipos.dao.getAll().length > 0) {
				Radar.ocorrencias.filtro.limpar();
			}
            
			if (usuario.dados.logado)
				Radar.app.goToPage('cadastrar');
			else {
				usuario.tamanhoTela();
				Radar.app.goToPage('login');
			}
		} else {
			navigator.notification.alert("Para continuar você deve selecione sua cidade e estado primeiro.", false, 'Localização', 'OK');
		}
	},

	deleteScroll: function () {
		if (this.scroller) {
			this.scroller.destroy();
			this.scroller = null;
		}
	},

	atualizarViews: function () {
		/*if (Radar.cidades.dao.carregado) {
			var licidade = $('#btn_selecionar_cidade');
			var liestado = $('#btn_selecionar_estado');
			var btnConfirmar = $('#btn_confirmar_cidade_estado');

			if (usuario.dados.cidade) {
				licidade.text(usuario.dados.cidade.nome);
				this.estado_selecionado = usuario.dados.cidade.estado;
				liestado.text(this.estado_selecionado);
				btnConfirmar.show();
			} else {
				licidade.text(langValue('select_city'));
				btnConfirmar.hide();
				if (this.estado_selecionado)
					liestado.text(this.estado_selecionado);
				else
					liestado.text(langValue('select_state'));
			}

			licidade.addClass('hasChild flaticon-chevrons');
			liestado.addClass('hasChild flaticon-chevrons');
		}*/
		
		if(usuario.dados.pais) {
			// legacy 1.2.9
			if(usuario.dados.pais.nome == "Paraguai" && Radar.lang.indexOf("es") != 0)
				usuario.dados.pais.nome = "Paraguay";
			$('.userpais span.ctr').text(usuario.dados.pais.nome);
		} else {
			$('.userpais span.ctr').text('');
		}
		
		if(usuario.dados.estado) {
			$('#btn_selecionar_estado').text(usuario.dados.estado.nome);
			$('#btn_selecionar_cidade').show();
		} else {
			$('#btn_selecionar_cidade').hide();
			if(Radar.strings)
				$('#btn_selecionar_estado').text(langValue("select_state"));
		}

		if(usuario.dados.cidade) {
			$('#btn_selecionar_cidade').text(usuario.dados.cidade.nome);
		} else {
			if(Radar.strings)
				$('#btn_selecionar_cidade').text(langValue("select_city"));
		}

		if(usuario.dados.pais && usuario.dados.estado && usuario.dados.cidade){
			$('#btn_confirmar_cidade_estado').show();
			$('#loading-loc, #info_cidade_estado .message.atencao').hide();
		} else {
			$('#btn_confirmar_cidade_estado').hide();
		}
	},


	selecionarCidade: function (element) {
		$('#selecionar_cidade .lista li').removeClass('selecionado');
		$(element).addClass('selecionado');
	},


	selecionarEstado: function (element) {
		$('#selecionar_estado .lista li').removeClass('selecionado');
		$(element).addClass('selecionado');
	},

	listaEstados: function () {
		Radar.app.goToPage('selecionar_estado');
	},

	listaCidades: function () {
		Radar.app.goToPage('selecionar_cidade');
		
		/*if (Radar.cidades.estado_selecionado || (usuario.dados.cidade && usuario.dados.cidade.estado)) {
			var html = "";
			var cidades = Radar.cidades.dao.getListaOrdenada();

			for (var i = 0; i < cidades.length; i++) {
				var cidade = cidades[i];
				if (cidade.estado == Radar.cidades.estado_selecionado && cidade.ativo) {
					html += '<li data-id="' + cidade.id + '" onclick="Radar.cidades.selecionarCidade(this);"><div>' + cidade.nome + '</div></li>'
				}
			}

			//html += '<li onclick="Radar.cidades.formCadastro();"><div class="flaticon-chevrons link">Não encontrei minha cidade, quero cadastrar.</div></li>';

			$('#selecionar_cidade .lista').html(html);
			$('#selecionar_cidade .lista li').removeClass('selecionado');

			Radar.app.goToPage('selecionar_cidade');
		} else {
			navigator.notification.alert("Selecione um estado para poder visualizar as cidades", false, 'Estado', 'OK');
		}*/
	},

	confirmarCidade: function () {
		
		$("#selecionar_cidade .lista .selecionado").each(function () {
			var cidades = Cookie.get('cidades');
			if(cidades) cidades = JSON.parse(cidades);
			
			for(var i=0; i<cidades.length; i++){
				if(cidades[i].id == this.getAttribute('data-value')){
					usuario.dados.cidade = cidades[i];
				}
			}
			return false;
		});

		if (usuario.dados.cidade) {
			//Radar.cidades.estado_selecionado = usuario.dados.cidade.estado;
			Radar.app.goToPage('info_cidade_estado', true);
			Radar.cidades.deleteScroll();
		} else {
			navigator.notification.alert(
				"Selecione uma cidade antes de continuar.", // message
				false, // callback
				'Cidade', // title
				'OK' // buttonName
			);
		}
	},
	
	confirmarEstado: function () {
		$("#selecionar_estado .lista .selecionado").each(function () {
			var estados = Cookie.get('estados');
			if(estados) estados = JSON.parse(estados);
			
			for(var i=0; i<estados.length; i++){
				if(estados[i].id == this.getAttribute('data-value')){
					usuario.dados.estado = estados[i];
				}
			}
			
			return false;
		});
		
		if (usuario.dados.estado) {
			$('#cadastrocidade_estado').text(usuario.dados.estado.nome);
			usuario.dados.cidade = undefined;
			Radar.cidades.atualizarViews();
			Radar.app.goToPage('info_cidade_estado', true);
			Radar.cidades.deleteScroll();
		} else {
			navigator.notification.alert(
				"Selecione um estado antes de continuar.", // message
				false, // callback
				'Estado', // title
				'OK' // buttonName
			);
		}
	},

	informacoesDetalhadas: function () {
		var url = Radar.app.SITE + '?pg=listacidade&tmpl=component&id=' + usuario.dados.cidade.id;

		$.getJSON(url, function (data) {
			Radar.cidades.termos = data.termos;

			data = data["0"];
			if (data) {
				usuario.dados.cidade.nome = data.nome;
				usuario.dados.cidade.sobre = data.sobre;
				usuario.dados.cidade.telefone1 = data.telefone1;
				usuario.dados.cidade.telefone2 = data.telefone2;
				usuario.dados.cidade.horario = data.horario;
				usuario.dados.cidade.observacao = data.observacao;
				usuario.dados.cidade.sobre = data.sobre;
				usuario.dados.cidade.logo = data.logo;
			}

			console.log("Informações detalhadas da cidade adquiridas com sucesso.");
			Radar.cidades.exibirInformacoesDetalhadas();
		}).fail(function () {
			console.log("Não foi possivel adquirir informações remotas sobre a cidade.");
		});
	},

	exibirInformacoesDetalhadas: function () {
		$('#sobre .cidadeid').attr('data-value', usuario.dados.cidade.id);

		if (usuario.dados.cidade.observacao.length > 0) {
			$('#sobre .observacao')
				.html(usuario.dados.cidade.observacao)
				.addClass('ativo');
		} else {
			$('#sobre .observacao').html("").removeClass('ativo');
		}

		if (usuario.dados.cidade.horario.length > 0) {
			$('#sobre .horario').text(usuario.dados.cidade.horario)
			$('#sobre .funcionamento').addClass('ativo');
		} else {
			$('#sobre .horario').text("").removeClass('ativo');
		}

		if (usuario.dados.cidade.telefone1.length > 0) {
			$('#sobre .tel1').text(usuario.dados.cidade.telefone1)
			$('#sobre .telefones').addClass('ativo');
		} else {
			$('#sobre .tel1').text("").removeClass('ativo');
		}

		if (usuario.dados.cidade.telefone2.length > 0) {
			$('#sobre .tel2').text(' - ' + usuario.dados.cidade.telefone2);
		} else {
			$('#sobre .tel2').text("");
		}

		if (usuario.dados.cidade.nome.length > 0) {
			$('#sobre .title').text(usuario.dados.cidade.nome + ' / ' + usuario.dados.estado.uf);
		} else {
			$('#sobre .title').text("");
		}

		if (usuario.dados.cidade.logo && usuario.dados.cidade.logo.length > 0) {
			var url = Radar.app.SITE + '/radarweb/images/logos/' + usuario.dados.cidade.logo
			$('#sobre .logo').get(0).src = url;
			$('#sobre .imagens').addClass('ativo');
		} else {
			$('#sobre .logo').get(0).src = "";
			$('#sobre .imagens').removeClass('ativo');
		}

		if (usuario.dados.cidade.sobre && usuario.dados.cidade.sobre.length > 0) {
			$('#sobre .sobre')
				.html(usuario.dados.cidade.sobre)
				.addClass('ativo');
		} else {
			$('#sobre .sobre').text("").removeClass('ativo');
		}

		if (usuario.dados.nome)
			$('#sobre #contatoform_nome').val(usuario.dados.nome);
		else
			$('#sobre #contatoform_nome').val("");

		if (usuario.dados.email)
			$('#sobre #contatoform_email').val(usuario.dados.email);
		else
			$('#sobre #contatoform_email').val("");

		if (Radar.cidades.informacoes_scroll) {
			Radar.cidades.informacoes_scroll.refresh();
		}

		$('#sobre .carregando').removeClass('ativo');
	},



	// util para diminuir o tamanho do json que deve ser baixado
	// retorna o estado baseando-se no uf
	getEstadoByUf: function (uf) {
		switch (uf.toUpperCase()) {
		case 'AC':
			return 'Acre';
		case 'AL':
			return 'Alagoas';
		case 'AP':
			return 'Amapá';
		case 'AM':
			return 'Amazonas';
		case 'BA':
			return 'Bahia';
		case 'CE':
			return 'Ceará';
		case 'DF':
			return 'Distrito Federal';
		case 'ES':
			return 'Espírito Santo';
		case 'GO':
			return 'Goiás';
		case 'MA':
			return 'Maranhão';
		case 'MT':
			return 'Mato Grosso';
		case 'MS':
			return 'Mato Grosso do Sul';
		case 'MG':
			return 'Minas Gerais';
		case 'PA':
			return 'Pará';
		case 'PB':
			return 'Paraíba';
		case 'PR':
			return 'Paraná';
		case 'PE':
			return 'Pernambuco';
		case 'PI':
			return 'Piauí';
		case 'RJ':
			return 'Rio de Janeiro';
		case 'RN':
			return 'Rio Grande do Norte';
		case 'RS':
			return 'Rio Grande do Sul';
		case 'RO':
			return 'Rondônia';
		case 'RR':
			return 'Roraima';
		case 'SC':
			return 'Santa Catarina';
		case 'SP':
			return 'São Paulo';
		case 'SE':
			return 'Sergipe';
		case 'TO':
			return 'Tocantins';
		}
	},

	sincronizar: function (showMessage) {
		$('#selecionar_cidade .carregando').addClass('ativo');

		Radar.cidades.download(function (success) {
			$('#selecionar_cidade .carregando').removeClass('ativo');
			if (success) {

				// atualizar data da ultima atualização
				var dtAtual = moment().format("YYYY-MM-DD HH:mm:ss");
				Cookie.set("last_update", dtAtual);

				if (showMessage) {
					navigator.notification.alert("As cidades foram sincronizadas com sucesso.", false, 'Sincronização', 'OK');
					Radar.cidades.listaCidades();
					if (Radar.cidades.scroller) {
						Radar.cidades.scroller.refresh();
					}
				} else {
					console.log("cidades sincronizadas com sucesso.");
				}


			} else {
				if (showMessage) {
					navigator.notification.alert("Não foi possivel sincronizar as cidades, tente novamente mais tarde.", false, 'Sincronização', 'OK');
				} else {
					console.log("Não foi possivel sincronizar as cidades.");
				}
			}
		});
	},

	download: function (callback) {
		var dtAtualizacao = Cookie.get('last_update', '0000-00-00 00:00:00');
		var url = Radar.app.SITE + '?pg=listacidade2&tmpl=component&cidade=1&data=' + dtAtualizacao;
		var that = Radar.cidades.dao;

		$.getJSON(url, function (json_cidades) {
			if (json_cidades != "") {
				try {
					$.each(json_cidades, function (index, city) {
						var uf = city.estado;
						var estado = Radar.cidades.getEstadoByUf(uf);
						var id = parseInt(city.id);

						var cidade = new Cidade({
							id: id,
							uf: uf,
							nome: city.nome,
							alias: city.alias,
							estado: estado,
							latitude: city.latitudecentral,
							longitude: city.longitudecentral,
							estado_id: city.estado_id
						});

						if (city.ativo == '1') {
							cidade.ativo = true;
						} else {
							cidade.ativo = false;
						}

						that.add(cidade);
					});

					that.salvar();
					if (callback != undefined) callback(true);
				} catch (error) {
					if (callback != undefined) callback(false);
					console.log(error);
				}
			} else {
				if (callback != undefined) callback(true);
				console.log("Nenhuma cidade retornada");
			}
		});
	}
};

Radar.cidades.formCadastro = function () {
	Radar.app.goToPage('cadastrar_cidade');

	document.getElementById('cadastrocidade_nome').value = usuario.dados.nome || '';
	document.getElementById('cadastrocidade_email').value = usuario.dados.email || '';
	document.getElementById('cadastrocidade_telefone').value = usuario.dados.telefone || '';

	var estado = usuario.dados.estado ? usuario.dados.estado.nome : undefined;
	document.getElementById('cadastrocidade_estado').innerText = estado || '';
};

Radar.cidades.cadastrar = function () {
	var nome = document.getElementById('cadastrocidade_nome');
	var email = document.getElementById('cadastrocidade_email');
	var telefone = document.getElementById('cadastrocidade_telefone');
	var cidade = document.getElementById('cadastrocidade_cidade');
	var estado = document.getElementById('cadastrocidade_estado');

	var erro = false;

	if (nome.value == '' || nome.value == undefined) {
		$(nome.parentElement).addClass('invalido');
		erro = true;
	}

	if (email.value == '' || email.value == undefined) {
		$(email.parentElement).addClass('invalido');
		erro = true;
	}

	if (telefone.value == '' || telefone.value == undefined) {
		$(telefone.parentElement).addClass('invalido');
		erro = true;
	}

	if (cidade.value == '' || cidade.value == undefined) {
		$(cidade.parentElement).addClass('invalido');
		erro = true;
	}

	if (!estado.innerText) {
		$(estado.parentElement).addClass('invalido');
		erro = true;
	}

	if (erro) {
		setTimeout(function () {
			$(nome.parentElement).removeClass('invalido');
			$(email.parentElement).removeClass('invalido');
			$(telefone.parentElement).removeClass('invalido');
			$(cidade.parentElement).removeClass('invalido');
			$(estado.parentElement).removeClass('invalido');
		}, 500);
	} else {
		var form = {
			nome: nome.value,
			email: email.value,
			telefone: telefone.value,
			cidade: cidade.value,
			estado: estado.innerText
		};
		this.enviarCadastro(form);
	}
};

Radar.cidades.enviarCadastro = function (form) {
	var postbody = "nome=" + form.nome +
		"&email=" + form.email +
		"&telefone=" + form.telefone +
		"&cidade=" + form.cidade +
		"&estado=" + form.estado +
		"&tmpl=json";

	$.ajax({
		type: 'POST',
		data: postbody,
		url: Radar.app.SITE + "/site/send.php",
		success: function (resposta) {
			var json;
			try {
				json = JSON.parse(resposta);
			} catch (error) {
				json = {
					msg: '',
					enviou: 0
				};
			}

			if (json.enviou == 1) {
				//sucesso
				Radar.app.goToPage('cidade_cadastrada');
				$('#cidade_cadastrada .carregando').css('display', 'none');
			} else {
				//fail
				navigator.notification.alert(
					"Não foi possivel cadastrar sua cidade.", // message
					false, // callback
					'Erro', // title
					'OK' // buttonName
				);
				Radar.app.goToPage('selecionar_cidade');
			}
		},
		error: function (request, status, error) {
			navigator.notification.alert("Não foi possivel comunicar-se com o servidor.", false, 'Erro', 'OK');
			Radar.app.goToPage('selecionar_cidade');
		}
	});
};


Radar.cidades.contato = function () {
	var nome = document.getElementById('contatoform_nome');
	var email = document.getElementById('contatoform_email');
	var msg = document.getElementById('contatoform_msg');
	var erro = false;

	if (nome.value == '') {
		$(nome.parentElement).addClass('invalido');
		erro = true;
	}

	if (email.value == '') {
		$(email.parentElement).addClass('invalido');
		erro = true;
	}

	if (msg.value == '') {
		$(msg.parentElement).addClass('invalido');
		erro = true;
	}

	if (erro) {
		setTimeout(function () {
			$(nome.parentElement).removeClass('invalido');
			$(email.parentElement).removeClass('invalido');
			$(msg.parentElement).removeClass('invalido');
		}, 200);
	} else {
		$('#sobre .carregando').addClass('ativo');
		Radar.app.gerarToken(function (token) {
			Radar.cidades.enviarMensagem({
				nome: nome.value,
				email: email.value,
				msg: msg.value,
				token: token
			});
		});
	}
};

Radar.cidades.enviarMensagem = function (form) {
	var postbody = "nome=" + form.nome +
		"&email=" + form.email +
		"&mensagem=" + form.msg +
		"&cidade=" + usuario.dados.cidade.id +
		"&" + form.token + "=1";

	$.ajax({
		type: 'POST',
		data: postbody,
		url: Radar.app.SITE + "?pg=sobre&task=send&tmpl=component",
		success: function (resposta) {
			var json;
			try {
				json = JSON.parse(resposta);
			} catch (error) {
				json = {
					msg: '',
					enviou: 0
				};
			}

			var enviou = json.enviou == 1 ? true : false;
			if (enviou) {
				navigator.notification.alert(
					"Sua mensagem foi enviada com sucesso.", // message
					false, // callback
					'Sucesso', // title
					'OK' // buttonName
				);
			} else {
				navigator.notification.alert(
					"Não foi possivel enviar a mensagem.", // message
					false, // callback
					'Erro', // title
					'OK' // buttonName
				);
			}
		},
		error: function (request, status, error) {
			navigator.notification.alert("Não foi possivel enviar a mensagem.", false, 'Erro', 'OK');
		},
		complete: function () {
			$('#sobre .carregando').removeClass('ativo');
		}
	});
};



Radar.cidades.dao = {
	//atributos
	url: "",
	cidades: [],
	carregado: false,

	//metodos

	getListaOrdenada: function () {
		var lista = [];
		for (var key in this.cidades) {
			lista.push(this.cidades[key]);
		}

		var orderedlist = lista.sort(function (a, b) {
			if (a.nome > b.nome) return 1;
			if (a.nome < b.nome) return -1;
			return 0;
		});

		return orderedlist;
	},

	salvar: function () {
		var json_cidades = "";
		json_cidades = JSON.stringify(this.cidades);
		Cookie.set('json_cidades', json_cidades);
	},

	carregarPorArquivo: function (callback) {
		var that = this;
		$.getJSON('cidades.json', function (array_cidades) {
			$.each(array_cidades, function (index, city) {
				var estado = Radar.cidades.getEstadoByUf(city.estado);
				var id = parseInt(city.id);
				var lat = city.latitudecentral || city.latitude;
				var lng = city.longitudecentral || city.longitude;

				var cidade = new Cidade({
					id: id,
					uf: city.estado,
					nome: city.nome,
					alias: city.alias,
					estado: estado,
					latitude: lat,
					longitude: lng
				});

				if (city.ativo == '1') {
					cidade.ativo = true;
				} else {
					cidade.ativo = false;
				}

				that.add(cidade);
			});

			that.salvar();

			that.carregado = true;
			if (callback != undefined) callback();
			Radar.app.carregamentoCompleto();
		}).fail(function () {
			console.log("Não foi possivel carregar as cidades.");
		});
	},

	carregar: function (callback) {
		this.cidades = {};
		var json_cidades;

		if (!Cookie.get('versao')) {
			json_cidades = undefined;
			Cookie.set('versao', '1');
		} else {
			json_cidades = Cookie.get('json_cidades');
		}

		if (json_cidades == undefined) {
			this.carregarPorArquivo(callback);
		} else {
			var that = this;
			var array_cidades = [];

			try {
				array_cidades = JSON.parse(json_cidades);
			} catch (e) {
				console.log('Não foi possivel converter a lista de cidades');
			}

			$.each(array_cidades, function (index, city) {
				var uf = city.uf;
				var estado = city.estado;
				if (!estado)
					estado = Radar.cidades.getEstadoByUf(uf);
				var id = parseInt(city.id);
				var lat = city.latitude;
				var lng = city.longitude;

				var cidade = new Cidade({
					id: id,
					uf: uf,
					nome: city.nome,
					alias: city.alias,
					estado: estado,
					latitude: lat,
					longitude: lng
				});

				if (city.ativo) {
					cidade.ativo = true;
				} else {
					cidade.ativo = false;
				}

				that.add(cidade);
			});

			that.salvar();

			that.carregado = true;
			if (callback != undefined) callback();
			Radar.app.carregamentoCompleto();
		}
	},

	getById: function (id) {
		return this.cidades[id];
	},

	add: function (cidade) {
		if (cidade.id != null) {
			this.cidades[cidade.id] = cidade;
		}
	},

	getAll: function () {
		return this.cidades;
	},

	get: function (index) {
		return this.cidades[index];
	},

	getByIp: function (callback) {
		var that = this;

		$.getJSON("http://ip-api.com/json/", function (data) {
			var city = undefined;

			if (data && data.city) {
				for (var id in that.cidades) {
					var cidade = that.cidades[id];
					var alias_igual = cidade.alias.toLowerCase() == data.city.toLowerCase();
					var nome_igual = cidade.nome.toLowerCase() == data.city.toLowerCase();
					var estado_igual = cidade.estado.substr(0, 1).toLowerCase() == data.regionName.substr(0, 1).toLowerCase();

					if ((alias_igual || nome_igual) && estado_igual) {
						city = cidade;
						break;
					}
				}
			}

			callback(city);
		}).fail(function () {
			callback(undefined);
		});
	},

	getAllByEstado: function (estado) {
		var lista = [];
		for (var id in this.cidades) {
			var cidade = this.cidades[id];
			if (cidade.estado == estado)
				lista.push(cidade);
		}
		return lista;
	}
};