function TipoOcorrencia(id, nome, icone){
	this.id = id;
	this.nome = nome;
	this.icone = icone;
}	

Radar.tipos = {};

Radar.tipos.dao = {
	url : "",
	tipos : [],
	carregado : false,
	
	carregar : function(callback){
        this.resetar();
		var that = this;
		var cid = 1;
        try { cid = usuario.dados.cidade.id } catch(e){}
		var urljson = Radar.app.SITE + '/?pg=listatipos&tmpl=component&cidade='+cid+'&lang='+Radar.lang;// + usuario.dados.cidade.id;
		$.getJSON(urljson, function( data ) {
			if(data[0]){
				that.url = data[0].caminho;
			}
			
			that.tipos = [];
			for(var i=1; i < data.length; i++){
				that.add(new TipoOcorrencia(data[i].id, data[i].nome, data[i].icone));
			}
			
			that.carregado = true;
			console.log("Tipos carregados.");
			
			if(callback) callback(true);
		}).fail(function() {
			if(callback) callback(false);
		});
	},
	
	get : function(index){
		return this.tipos[index];	
	},
	
	getAll: function(){
		return this.tipos;	
	},
	
	getById : function(id){
		var result = undefined;
		for(var i=0; i < this.tipos.length; i++){
			if(this.tipos[i].id == id){
				result = this.tipos[i];
				break;
			}
		}
		return result;
	},
	
	add : function(tipo){
		if(tipo.id != null){
			this.tipos.push(tipo);
		}
	},
	
	resetar: function(){
		this.tipos = [];
		this.carregado = false;
		this.url = "";
	}
};

TipoOcorrencia.prototype = {
	getIconUrl: function(){
		return Radar.tipos.dao.url + this.icone;
	}
};